'=========================================================================================
' Winamp Control Script by Tadis

'=========================================================================================
' More information on this widget can be found at myweb.tiscali.co.uk/sidat/
'
' Please format your AMIP Winamp plugin as follows:
'
'   file: C:\Program Files\Samurize\NowPlaying.txt
'   while playing: %1||%2||%3||%4||%fn||%ll||playing||%min:%sec
'   while paused: %1||%2||%3||%4||%fn||%ll||paused||%min:%sec
'   while: %1||%2||%3||%4||%fn||%ll||stopped||%min:%sec
'   on exit:
'
'
'=============================================================================
'=============================================================================
'=============================================================================

On Error Resume Next

Dim arg, strArg
Dim WshShell
Set WshShell = createobject("wscript.shell")

strAMPPath = WshShell.RegRead ("HKCU\Software\Winamp\")
strSamPath = WshShell.RegRead ("HKCU\Software\Serious Samurize\")

If WScript.Arguments.Count = 0 Then
   'WScript.Echo  "no argument on the command line."
Else
	For each arg in WScript.Arguments  
		strArg = cStr(arg)

		Select Case strArg
		Case "Forward"
		RForward

		Case "Next"
		RNext

		Case "Pause"
		RPause

		Case "Play"
		RPlay

		Case "Playlist"
		RPlaylist

		Case "Previous"
		RPrevious

		Case "Rewind"
		RRewind

		Case "Stop"
		RStop

		Case "Winamp"
		RWinamp

		Case "Close"
		WinampOpenClose

		Case Else
		End Select
	Next
End If

WScript.Quit(0)

'================================================================================================
'================================================================================================
'================================================================================================

Function RPrevious
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "prev" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RRewind
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "rewind_5_seconds" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RPlay
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "play" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RPause
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "pause" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RStop
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "stop" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RForward
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "forward_5_seconds" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RNext
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "next" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RPlaylist
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "toggle_playlist" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function RWinamp
On Error Resume Next

Dim WshShell
Set WshShell = createobject("wscript.shell")

strWinampPath = chr(34) & strSamPath  & "\Scripts\Milk Vertical\Winamp.exe " & _
		chr(34) & "show_winamp" & chr(34)

WshShell.Run strWinampPath , 0, TRUE

Set WshShell = Nothing
End Function

'================================================================================================

Function startWinamp()
On Error Resume Next
 Dim objWMIService, colProcessList, WshShell
 Set objWMIService = GetObject("winmgmts:root\cimv2")
 Set colProcessList = objWMIService.ExecQuery ("Select * from Win32_Process")

 For Each objProcess in colProcessList
   If objProcess.Name="winamp.exe" Then
     WinampLive = True
     Exit For
   Else
     WinampLive = False
   End If   
 Next

 If WinampLive = False Then
   Set WshShell = CreateObject("WScript.Shell")
   WshShell.Exec(WINAMP_DIRECTORY & "\Winamp.exe")
   Set WshShell = Nothing
 End If

 Set objWMIService = Nothing
 Set colProcessList = Nothing
End Function

'================================================================================================

Function WinampOpenClose()
'On Error Resume Next
 Dim objWMIService, colProcessList, WshShell
 Set objWMIService = GetObject("winmgmts:root\cimv2")
 Set colProcessList = objWMIService.ExecQuery ("Select * from Win32_Process")

 For Each objProcess in colProcessList
   If objProcess.Name="winamp.exe" Then
     WinampLive = True
     Exit For
   Else
     WinampLive = False
   End If   
 Next

 If WinampLive = False Then
   Set WshShell = CreateObject("WScript.Shell")
   WshShell.Exec(strAMPPath & "\Winamp.exe")
   Wscript.Sleep(500)
   WinampDown
   Wscript.Sleep(500)
   RPlay
   Set WshShell = Nothing
 Else
   strProcess = "Winamp.exe"
   KillClient(strProcess)
   Wscript.Sleep(500)
   WinampUp
 End If

 Set objWMIService = Nothing
 Set colProcessList = Nothing
End Function

'================================================================================================

Function KillClient(vProcess)
 Dim objWMIService, colProcessList, objProcess, PID
   Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
   Set colProcessList = objWMIService.ExecQuery("select * from Win32_Process where CommandLine LIKE '%" & vProcess & "%'")
   For Each objProcess in colProcessList
     PID = objProcess.ProcessID
     killPID(PID)
   Next
End Function

Function killPID(PID)
 Dim WshShell
 Set WshShell = CreateObject("wscript.shell")
 WshShell.run "taskkill /PID " & PID, 0
End Function

'================================================================================================
'================================================================================================
'================================================================================================