'file: I:\Program Files\Winamp\NowPlaying.txt
'while playing: %1||%2||%3||%4||%fn||%ll||playing||%min:%sec
'while paused: %1||%2||%3||%4||%fn||%ll||paused||%min:%sec
'while: %1||%2||%3||%4||%fn||%ll||stopped||%min:%sec
'on exit:

'=============================================================================
'=============================================================================
'=============================================================================

Function VerticalScroll (AIMPFile , scrollLength , Divider)
On Error Resume Next

Divider = " " & Divider & " "

strA = Divider & WinampGetInfo("artist", AIMPFile)
strB = Divider & WinampGetInfo("song", AIMPFile)

myString = strA & strB
mystring = scrollText(myString, scrollLength)
myLen = cInt(Len(myString))

For i = 1 to myLen
  result = result & Mid(myString , i, 1) & "%b"
Next

VerticalScroll = result

'If err.number <> 0 Then VerticalScroll = "Winamp Inactive"

End Function

'=============================================================================

Function ScrollTwoLines (AIMPFile , scrollLength , Divider)
On Error Resume Next

Divider = " " & Divider & " "

If WinampGetInfo("artist", AIMPFile) = "" Then 
  ScrollTwoLines = scrollText(Divider & "Winamp Inactive" , scrollLength)
  Exit Function
End If

strA = scrollText( (Divider & WinampGetInfo("artist", AIMPFile)) , scrollLength)
strB = scrollText( (Divider & WinampGetInfo("song", AIMPFile)), scrollLength)

ScrollTwoLines = strA & "%b" & strB

If err.number <> 0 Then ScrollTwoLines = "Winamp Inactive"

End Function

'=============================================================================

Function scrollArtistTrackTime(Divider , AIMPFile , scrollLength)
On Error Resume Next

Divider = " " & Divider & " "
myArtist = winampGetInfo ("artist", AIMPFile)
myTrack  = winampGetInfo ("song", AIMPFile)
myTime = winampGetInfo ("ctime", AIMPFile)

scrollArtistTrackTime = scrollText( (myArtist & Divider & myTrack & Divider & MyTime & Divider) , scrollLength)

If err.number <> 0 Then scrollArtistTrackTime = "Winamp Inactive"

End Function 

'=============================================================================
'=============================================================================
'=============================================================================

Function scrollText(myText, scrollLength)
On Error Resume Next

	On Error Resume Next
	temp = myText & DIVIDER
	startPos = (Timer) Mod Len(temp) + 1
	scrollText = mid(temp, startPos, scrollLength)
	scrollText = scrollText & mid(temp, 1, scrollLength - Len(scrollText))
End Function

'=============================================================================

Function winampGetInfo(item , playing)
On Error Resume Next

 Set fileObj = CreateObject("Scripting.FileSystemObject")
     size   = fileObj.GetFile(playing).Size
     exists = fileObj.FileExists(playing)
 If exists = True And size <> 0 Then
   Set file = fileObj.OpenTextFile(playing, 1)
   textResult = file.ReadLine
file.Close
Set fileObj = Nothing
itemArray = Split(textResult, "||")
   Select Case item
     Case "artist"
       winampGetInfo = itemArray(0)
     Case "song"
       winampGetInfo = itemArray(1)
     Case "track"
       winampGetInfo = itemArray(2)
     Case "album"
       winampGetInfo = itemArray(3)
    Case "path"
       winampGetInfo = itemArray(4)
    Case "count"
       winampGetInfo = itemArray(5)
    Case "status"
       winampGetInfo = itemArray(6)
    Case "ctime"
       winampGetInfo = itemArray(7)
   End Select    
 Else
   winampGetInfo = ""
 End If

End Function
 
